package com.chinaitop.depot.intelligent.ventilation.model;

import java.util.ArrayList;
import java.util.List;

public class TCtldevinfoBypeExample {
    /**
     * t_ctldevinfo_bype
     */
    protected String orderByClause;

    /**
     * t_ctldevinfo_bype
     */
    protected boolean distinct;

    /**
     * t_ctldevinfo_bype
     */
    protected List<Criteria> oredCriteria;

    public TCtldevinfoBypeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_ctldevinfo_bype 2021-05-17
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andTcIdIsNull() {
            addCriterion("tc_id is null");
            return (Criteria) this;
        }

        public Criteria andTcIdIsNotNull() {
            addCriterion("tc_id is not null");
            return (Criteria) this;
        }

        public Criteria andTcIdEqualTo(Integer value) {
            addCriterion("tc_id =", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdNotEqualTo(Integer value) {
            addCriterion("tc_id <>", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdGreaterThan(Integer value) {
            addCriterion("tc_id >", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("tc_id >=", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdLessThan(Integer value) {
            addCriterion("tc_id <", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdLessThanOrEqualTo(Integer value) {
            addCriterion("tc_id <=", value, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdIn(List<Integer> values) {
            addCriterion("tc_id in", values, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdNotIn(List<Integer> values) {
            addCriterion("tc_id not in", values, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdBetween(Integer value1, Integer value2) {
            addCriterion("tc_id between", value1, value2, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcIdNotBetween(Integer value1, Integer value2) {
            addCriterion("tc_id not between", value1, value2, "tcId");
            return (Criteria) this;
        }

        public Criteria andTcCodeIsNull() {
            addCriterion("tc_code is null");
            return (Criteria) this;
        }

        public Criteria andTcCodeIsNotNull() {
            addCriterion("tc_code is not null");
            return (Criteria) this;
        }

        public Criteria andTcCodeEqualTo(Integer value) {
            addCriterion("tc_code =", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeNotEqualTo(Integer value) {
            addCriterion("tc_code <>", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeGreaterThan(Integer value) {
            addCriterion("tc_code >", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("tc_code >=", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeLessThan(Integer value) {
            addCriterion("tc_code <", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeLessThanOrEqualTo(Integer value) {
            addCriterion("tc_code <=", value, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeIn(List<Integer> values) {
            addCriterion("tc_code in", values, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeNotIn(List<Integer> values) {
            addCriterion("tc_code not in", values, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeBetween(Integer value1, Integer value2) {
            addCriterion("tc_code between", value1, value2, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("tc_code not between", value1, value2, "tcCode");
            return (Criteria) this;
        }

        public Criteria andTcNameIsNull() {
            addCriterion("tc_name is null");
            return (Criteria) this;
        }

        public Criteria andTcNameIsNotNull() {
            addCriterion("tc_name is not null");
            return (Criteria) this;
        }

        public Criteria andTcNameEqualTo(String value) {
            addCriterion("tc_name =", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameNotEqualTo(String value) {
            addCriterion("tc_name <>", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameGreaterThan(String value) {
            addCriterion("tc_name >", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameGreaterThanOrEqualTo(String value) {
            addCriterion("tc_name >=", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameLessThan(String value) {
            addCriterion("tc_name <", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameLessThanOrEqualTo(String value) {
            addCriterion("tc_name <=", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameLike(String value) {
            addCriterion("tc_name like", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameNotLike(String value) {
            addCriterion("tc_name not like", value, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameIn(List<String> values) {
            addCriterion("tc_name in", values, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameNotIn(List<String> values) {
            addCriterion("tc_name not in", values, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameBetween(String value1, String value2) {
            addCriterion("tc_name between", value1, value2, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcNameNotBetween(String value1, String value2) {
            addCriterion("tc_name not between", value1, value2, "tcName");
            return (Criteria) this;
        }

        public Criteria andTcStartIsNull() {
            addCriterion("tc_start is null");
            return (Criteria) this;
        }

        public Criteria andTcStartIsNotNull() {
            addCriterion("tc_start is not null");
            return (Criteria) this;
        }

        public Criteria andTcStartEqualTo(String value) {
            addCriterion("tc_start =", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartNotEqualTo(String value) {
            addCriterion("tc_start <>", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartGreaterThan(String value) {
            addCriterion("tc_start >", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartGreaterThanOrEqualTo(String value) {
            addCriterion("tc_start >=", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartLessThan(String value) {
            addCriterion("tc_start <", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartLessThanOrEqualTo(String value) {
            addCriterion("tc_start <=", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartLike(String value) {
            addCriterion("tc_start like", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartNotLike(String value) {
            addCriterion("tc_start not like", value, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartIn(List<String> values) {
            addCriterion("tc_start in", values, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartNotIn(List<String> values) {
            addCriterion("tc_start not in", values, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartBetween(String value1, String value2) {
            addCriterion("tc_start between", value1, value2, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStartNotBetween(String value1, String value2) {
            addCriterion("tc_start not between", value1, value2, "tcStart");
            return (Criteria) this;
        }

        public Criteria andTcStopIsNull() {
            addCriterion("tc_stop is null");
            return (Criteria) this;
        }

        public Criteria andTcStopIsNotNull() {
            addCriterion("tc_stop is not null");
            return (Criteria) this;
        }

        public Criteria andTcStopEqualTo(String value) {
            addCriterion("tc_stop =", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopNotEqualTo(String value) {
            addCriterion("tc_stop <>", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopGreaterThan(String value) {
            addCriterion("tc_stop >", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopGreaterThanOrEqualTo(String value) {
            addCriterion("tc_stop >=", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopLessThan(String value) {
            addCriterion("tc_stop <", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopLessThanOrEqualTo(String value) {
            addCriterion("tc_stop <=", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopLike(String value) {
            addCriterion("tc_stop like", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopNotLike(String value) {
            addCriterion("tc_stop not like", value, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopIn(List<String> values) {
            addCriterion("tc_stop in", values, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopNotIn(List<String> values) {
            addCriterion("tc_stop not in", values, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopBetween(String value1, String value2) {
            addCriterion("tc_stop between", value1, value2, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcStopNotBetween(String value1, String value2) {
            addCriterion("tc_stop not between", value1, value2, "tcStop");
            return (Criteria) this;
        }

        public Criteria andTcByteIsNull() {
            addCriterion("tc_byte is null");
            return (Criteria) this;
        }

        public Criteria andTcByteIsNotNull() {
            addCriterion("tc_byte is not null");
            return (Criteria) this;
        }

        public Criteria andTcByteEqualTo(String value) {
            addCriterion("tc_byte =", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteNotEqualTo(String value) {
            addCriterion("tc_byte <>", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteGreaterThan(String value) {
            addCriterion("tc_byte >", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteGreaterThanOrEqualTo(String value) {
            addCriterion("tc_byte >=", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteLessThan(String value) {
            addCriterion("tc_byte <", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteLessThanOrEqualTo(String value) {
            addCriterion("tc_byte <=", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteLike(String value) {
            addCriterion("tc_byte like", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteNotLike(String value) {
            addCriterion("tc_byte not like", value, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteIn(List<String> values) {
            addCriterion("tc_byte in", values, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteNotIn(List<String> values) {
            addCriterion("tc_byte not in", values, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteBetween(String value1, String value2) {
            addCriterion("tc_byte between", value1, value2, "tcByte");
            return (Criteria) this;
        }

        public Criteria andTcByteNotBetween(String value1, String value2) {
            addCriterion("tc_byte not between", value1, value2, "tcByte");
            return (Criteria) this;
        }

        public Criteria andUpOrDownIsNull() {
            addCriterion("up_or_down is null");
            return (Criteria) this;
        }

        public Criteria andUpOrDownIsNotNull() {
            addCriterion("up_or_down is not null");
            return (Criteria) this;
        }

        public Criteria andUpOrDownEqualTo(Integer value) {
            addCriterion("up_or_down =", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownNotEqualTo(Integer value) {
            addCriterion("up_or_down <>", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownGreaterThan(Integer value) {
            addCriterion("up_or_down >", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownGreaterThanOrEqualTo(Integer value) {
            addCriterion("up_or_down >=", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownLessThan(Integer value) {
            addCriterion("up_or_down <", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownLessThanOrEqualTo(Integer value) {
            addCriterion("up_or_down <=", value, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownIn(List<Integer> values) {
            addCriterion("up_or_down in", values, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownNotIn(List<Integer> values) {
            addCriterion("up_or_down not in", values, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownBetween(Integer value1, Integer value2) {
            addCriterion("up_or_down between", value1, value2, "upOrDown");
            return (Criteria) this;
        }

        public Criteria andUpOrDownNotBetween(Integer value1, Integer value2) {
            addCriterion("up_or_down not between", value1, value2, "upOrDown");
            return (Criteria) this;
        }
    }

    /**
     * t_ctldevinfo_bype
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_ctldevinfo_bype 2021-05-17
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}